#include <iostream>
#include <stdio.h>
using namespace std;

int main()
{
    int n,k1,k,i,nn=0;
    int niz[200000];
    int nz[200000];
    scanf("%d%d",&n,&k);
    k1=k;
    for(int j=0;j<n;j++)
    {
        scanf("%d",&niz[j]);
        if(niz[j]!=1 && niz[j]!=0) nn=1;
    }
   
    if(nn)
    {for(int i=0;i<n;i++)
    {
        if(niz[i]>=niz[i+1] && k)
            {nz[i]=0; k--;}
        else nz[i]=1;
    }

    for(i=0;i<n;i++)
    {
        if(nz[i]) printf("%d ",niz[i]);
    }}
    else for(i=0;i<n;i++)
    {
        if(niz[i] && k) k--;
        else printf("%d ",niz[i]);
    }
    return 0;
}